/*!
 * @author wanglong@zhongsou.com   ddd
 */
(function() {
	var addEventListener = window.addEventListener || function(n, f) {
		window.attachEvent('on' + n, f);
	};
	var removeEventListener = window.removeEventListener || function(n, f, b) {
		window.detachEvent('on' + n, f);
	};
	var cache = [];
	var addObservers = function() {
		addEventListener('scroll', throttledLoad);
		addEventListener('resize', throttledLoad);
	};
	var removeObservers = function() {
		removeEventListener('scroll', throttledLoad, false);
		removeEventListener('resize', throttledLoad, false);
	};
	var scrollTimeoutHolder = null;
	var throttledLoad = function() {
		clearTimeout(scrollTimeoutHolder);
		scrollTimeoutHolder = setTimeout(function() {
			loadVisibleImages();
		}, 300);
	};
	var ajax = function(url, callback) {
		var req = new XMLHttpRequest();
		req.onreadystatechange = function() {
			if (this.readyState == 4 && this.status == 200) {
				callback.apply(this, [ eval('(' + this.responseText + ')') ])
			} else {
				callback.apply(this, {
					code : 500
				})
			}
		}
		req.open("GET", url, true);
		req.send();
	}
	/*************************begin*************************/
	var getImageSrc = function(img) {
		var keys = [ "src", "source", "srcori" ]
		for ( var i in keys) {
			var val = img.getAttribute(keys[i])
			if (val && !(val.match(/d3api2.+none.*\.png$/))) {
				return val;
			}
		}
		return ''
	}
	var wrapImgWithLinkAfterLoadHtml = function(img, i, inSouyue, hasPic) {
		var needCreateA = img.parentNode.tagName.toUpperCase() != 'A'
		var a = needCreateA ? document.createElement("a") : img.parentNode;
		if (inSouyue) {
			a.setAttribute("href", "showimage://" + i)
		} else {
			a.setAttribute("href", getImageSrc(img))
			a.setAttribute("rel", "external")
		}
		if (needCreateA) {
			img.parentNode.insertBefore(a, img);
			img.parentNode.removeChild(img);
			a.appendChild(img);
		}
		a.onclick = function() {
			if (!hasPic) {
				var img = a.querySelector("img")
				var src = img.getAttribute("src")
				var srcori = img.getAttribute("srcori")
				if (src && srcori && src != srcori) {
					img.setAttribute("src", srcori)
					img.style['opacity'] = '1.0'
					return false;
				}
			}
			return true;
		}
	}
	/**
	 * 支持无图模式，点击后查看图片
	 * 在搜悦中用相册方式查看图片
	 * 在其他处用相册方式查看图片
	 */
	var doAfterLoadHtml = function() {
		//其他引用js的地方忽略操作
		if (window.inUrlContent != true) {
			var fontsize = getCookie("fontsize");
			var vc = getCookie("vc")||0;
			if(parseInt(vc)>=5.0){
				var setting = {"fontsize":fontsize};
				changeFontSize(setting);
			}
			return;
		}
		//如果是在3g下的话，就不进入图片详情页
		if(hasClass('is-3g')){
			return;
		}

		var imgs = document.querySelectorAll(".souyue-image img");
		if (window.inSouyue == true) {
			window.images = []//搜悦内部看图
		}
		for ( var i = 0; i < imgs.length; i++) {
			var img = imgs[i]
			if (window.inSouyue == true) {
				images.push(getImageSrc(img))
			} else {
				img.setAttribute("alt", "(" + (i + 1) + "/" + imgs.length + ")")//相册alt
			}
			wrapImgWithLinkAfterLoadHtml(img, i, window.inSouyue == true, window.hasPic == true);
		}
		if (window.inSouyue == true) {
			images = images.join(" ")
			if (window.JavascriptInterface && JavascriptInterface.setImages) {
				JavascriptInterface.setImages(images);
			}
		} else {
			var _imgs = window.document.querySelectorAll('.souyue-image a')
			if (_imgs && _imgs.length > 0) {
				instance = Code.PhotoSwipe.attach(_imgs, {});
			}
		}

		var fontsize = getCookie("fontsize");
		var vc = getCookie("vc");
		if(parseInt(vc)>=5.0){
			var setting = {"fontsize":fontsize};
			changeFontSize(setting);
		}
	}
	/*************************end*************************/
	var initImageLazyLoader = function() {
		var imageNodes = document.querySelectorAll('img[source]');
		for ( var i = 0; i < imageNodes.length; i++) {
			var imageNode = imageNodes[i];
			cache.push(imageNode);
		}
		addObservers();
		loadVisibleImages();
	}
	window.loadMore = function(url) {
		var loader = document.getElementById("souyue-load-more");
		var content = document.getElementById("souyue-content");
		var loadImg = document.getElementById("souyue-loader");
		loadImg.setAttribute("src", "/d3api2/read/images/loading.gif")
		ajax("/d3api2/webdata/urlContentAjax.groovy?url=" + encodeURIComponent(url), function(json) {
			loadImg.setAttribute("src", "/d3api2/read/images/down.png")
			if (json.code == 200) {
				var html = json.html
				if (window.hasPic != true) {
					html = html.replace(/\/d3api2\/read\/images\/none.png/g, "/d3api2/read/images/none-down.png")
				}
				content.innerHTML = content.innerHTML + html;
				/**/
				initImageLazyLoader();
				/**/
				doAfterLoadHtml()
				if (json.nextUrl) {
					loader.setAttribute("href", "javascript:loadMore('" + json.nextUrl + "')")
				} else {
					loader.parentNode.removeChild(loader)
				}
			} else {//error
			}
		});
	}
	var loadVisibleImages = function() {
		var scrollY = window.pageYOffset || document.documentElement.scrollTop;
		var pageHeight = window.innerHeight || document.documentElement.clientHeight;
		var min = scrollY - 200;
		var max = scrollY + pageHeight + 200;
		var i = 0;
		while (i < cache.length) {
			var image = cache[i];
			var imagePosition = getOffsetTop(image);
			var imageHeight = image.height || 0;
			if ((imagePosition >= min - imageHeight) && (imagePosition <= max)) {
				image.onload = function() {
					var _souyue = this.parentElement;
					var _span = this.parentNode.parentElement||0;
					this.className = 'lazy-loaded';
					var cssText = image.style.cssText;
					cssText +='opacity:1;-webkit-transition:opacity 600ms ease';
					this.style.cssText = cssText;
					removeClass(_souyue,'souyue-image-default');//删除掉默认背景图
					if(_span){
						removeClass(_span,'souyue-image-default');//删除掉默认背景图
					}
					//兼容性处理，避免两个souyue-image样式出现
					if(_souyue&&_span&&hasClass(_souyue,"souyue-image")&&hasClass(_span,"souyue-image")){
						removeClass(_souyue,"souyue-image")
					}
				};
				image.onerror = function() {
					var cssText = this.style.cssText;
					cssText +='height:220px';
					this.style.cssText = cssText;
					//this.alt="图片加载失败！";
					this.removeAttribute("src");
					this.removeAttribute("width");
					this.removeAttribute("height");
				};
				image.src = image.getAttribute('source');
				image.removeAttribute('source');
				cache.splice(i, 1);
				continue;
			}
			i++;
		}
		if (cache.length === 0) {
			removeObservers();
		}
	};
	/**
	 * 锚点
	 */
	var onGotoSRP = function() {
		var as = document.getElementsByTagName("a");
		for ( var i = 0; i < as.length; i++) {
			as[i].onclick = function() {
				var href = decodeURIComponent(this.getAttribute("href"));
				if (href.indexOf("#keyword=") == 0) {
					if (window.JavascriptInterface && JavascriptInterface.gotoSRP) {
						href = href.replace(/(#keyword=)|(srpId=)/g, '').split('&');
						if (href.length >= 1) {
							JavascriptInterface.gotoSRP(href[0], href.length >=2 && href[1] ?href[1]:'none');
							return false;
						}
					} else {
						if (href.indexOf("&ANCHOR_R=") >= 0) {
							href = href.replace(/&ANCHOR_R=.*$/, "&ANCHOR_R=" + Math.random())
						} else {
							href += "&ANCHOR_R=" + Math.random()
						}
						this.setAttribute("href", href)
					}
				}
				return true;
			}
		}
	};

	var init = function() {
		onGotoSRP();
		if (!document.querySelectorAll) {
			document.querySelectorAll = function(selector) {
				var doc = document;
				var head = doc.documentElement.firstChild;
				var styleTag = doc.createElement('STYLE');
				head.appendChild(styleTag);
				doc.__qsaels = [];
				styleTag.styleSheet.cssText = selector + "{x:expression(document.__qsaels.push(this))}";
				window.scrollBy(0, 0);
				return doc.__qsaels;
			}
		}
		var _lazyLoaderInit = function() {
			var vc =getCookie('vc')||0;
			if(parseInt(vc)>=5){
				resetImageSize();
				//设置环境是wifi还是cookie
				var cookieWifi = getCookie('wifi');
				var cookieHasPic = getCookie('hasPic');
				var isWifi = (cookieWifi!=='0'||cookieHasPic!=='0');
				if(!isWifi){
					//环境在3g下、
					tapIn3g();
				}else{
					doAfterLoadHtml();
					//			setDownloadLind();
					setTimeout(function() {
						initImageLazyLoader();
					}, 300);//延迟一段时间开始加载可视区图片
					//removeEventListener('load', _lazyLoaderInit, false);
				}
			}else{
				doAfterLoadHtml();
				//			setDownloadLind();
				setTimeout(function() {
					initImageLazyLoader();
				}, 300);//延迟一段时间开始加载可视区图片
			}
		};

		//addEventListener('load', _lazyLoaderInit);
		document.addEventListener('DOMContentLoaded', _lazyLoaderInit)
	};
	//	}
	var getOffsetTop = function(el) {
		var val = 0;
		if (el.offsetParent) {
			do {
				val += el.offsetTop;
			} while (el = el.offsetParent);
			return val;
		}
	};
	init();

	//5.0添加的新功能============begin======================

    //1设置详情页字体大小
	window.changeFontSize = function(setting){
		if(setting&&setting.fontsize){
			var classArry = ['big','middle','small'];
			var _fontSize = setting.fontsize;
			var otherArry = classArry.filter(function(item){return item!==_fontSize});
			var _el = document.querySelector('.souyue-body')||document.querySelector('.main');
			if(!_el){return;}
			var _classList = _el.className.split(/\s+/g);
			var newClass = [_fontSize];
			_classList.forEach(function(klass){
				//有相同的class,不做处理
				if(klass===setting.fontsize){
					return
				}else {
					if (otherArry.indexOf(klass)===-1) {
						//没有其它的值
						newClass.push(klass);
					}
				}
			});
			_el.className = newClass.join(' ');
		}
	}

	//2 给每个预制大小了的img设置宽高
	function resetImageSize (){
		var obj = document.getElementById('souyue-content')||document.getElementById('ugc-content')
		var width = obj.offsetWidth-6;
		var _imgs = Array.prototype.slice.call(document.querySelectorAll('img'));
		_imgs.forEach(function(item,index){
			var _width = item.getAttribute('data-w')?item.getAttribute('data-w').replace('px',''):0;
			var _height = item.getAttribute('data-h')?item.getAttribute('data-h').replace('px',''):0;
			var _souyue = item.parentElement;
			if(hasClass(_souyue,"noClass")||hasClass(_souyue,"souyue-image")){
			}else{
				_souyue =item.parentElement.parentElement;
			}
			if(_width&&_height){
				var _finalHeight = (width*_height/_width)|0;
				if(_finalHeight){
					var cssText = _souyue.style.cssText;
					cssText +='width:'+width+'px;height:'+_finalHeight+'px;';
					_souyue.style.cssText = cssText;
				}
			}
			//有长有宽
			if(_width&&_height){
				//有长有宽
				var _finalHeight
				var cssText = _souyue.style.cssText;
				if(_width>=width){
					_finalHeight = (width*_height/_width)|0;
					if(_finalHeight){
						//marginBottom:16是为了原先的详情页的margin就是16px;
						cssText +='width:'+width+'px;height:'+_finalHeight+'px;';
						_souyue.style.cssText = cssText;
					}
				}else{
					//显示原有的尺寸宽度
					cssText +='_width:'+width+'px;height:'+_height+'px;';
					_souyue.style.cssText = cssText;
				}
			}
		});
	}


	//3 3g-绑定事件
	function tapIn3g(){
		var _imgs = Array.prototype.slice.call(document.querySelectorAll('img'));
		_imgs.forEach(function(item,index){
			//添加样式is-3g(标识为未打开，不能通过搜悦相册查看器查看)
			addClass(item,'is-3g');
			//添加onclick事件，点击图片区域进行加载图片
			item.addEventListener('click',function(e){
				if(item.className.indexOf('is-3g')===-1){
					return;
				}
				e.stopPropagation();
				e.preventDefault();
				removeClass(item,'is-3g')
				addClass(item,'lazy-loaded');
				var _souyue = item.parentElement;
				var _span = item.parentNode.parentElement||0;
				removeClass(_souyue,'souyue-image-default');//删除掉默认背景图
				if(_span){
					removeClass(_span,'souyue-image-default');//删除掉默认背景图
				}
				var retina = window.devicePixelRatio > 1
				var attrib = retina ? "data-src-retina" : "data-original";
				var source = item.getAttribute(attrib);
				source = source || item.getAttribute("source") || item.getAttribute("data-src") || item.getAttribute("data-url");
				if (item.not_new == "yes") {
					return false
				}
				if (source) {
					item.jumei_bg = item.src;
					item.onerror = function() {
						item.not_new = "yes";
						item.setAttribute("src", this.jumei_bg);
						//modifyCss(item,{"opacity": 1, "-webkit-transition": "all 600ms ease"})
						var cssText = item.style.cssText;
						cssText +='"opacity":1,"-webkit-transition":"opacity 600ms ease"';
						item.style.cssText = cssText;
						//$(this).css({"opacity": 1, "-webkit-transition": "all 600ms ease"})
					};
					item.onload = function() {
						item.not_new = "yes";
						var cssText = item.style.cssText;
						cssText +='opacity:1;-webkit-transition:opacity 600ms ease';
						item.style.cssText = cssText;
						//兼容性处理，避免两个souyue-image样式出现
						if(_souyue&&_span&&hasClass(_souyue,"souyue-image")&&hasClass(_span,"souyue-image")){
							removeClass(_souyue,"souyue-image")
						}
					};
					item.setAttribute("src", source);
					if (typeof callback === "function") {
						callback.call(this)
					}
				}
			});
		});
	}

	//获取cookie
	function getCookie(name){
		var strCookie=document.cookie;
		var arrCookie=strCookie.split("; ");
		for(var i=0;i<arrCookie.length;i++){
			var arr=arrCookie[i].split("=");
			if(arr[0]==name) {
				return arr[1];
			}
		}
		return "";
	}

	//判断是否有这个样式
	function hasClass(obj, cls) {
		if(!obj.className) return false;
		return obj.className.match(new RegExp('(\\s|^)' + cls + '(\\s|$)'));
	}

	//添加样式
	function addClass(obj, cls) {
		if (!hasClass(obj, cls)) obj.className += " " + cls;
	}

	//删除样式
	function removeClass(obj, cls) {
		if (hasClass(obj, cls)) {
			var reg = new RegExp('(\\s|^)' + cls + '(\\s|$)');
			obj.className = obj.className.replace(reg, ' ');
		}
	}

	//修改style样式
	function modifyCss(obj,css){
		for(var key in css){
			obj.style.key=css[key];
		}
	}

	//页面渲染完毕，再添加相关数据中圈子的图片
	document.addEventListener('DOMContentLoaded',function(){
		var image = document.getElementById("_mInterestLogo");
		if(image){
			setTimeout(function() {
				image.src=image.getAttribute("source2")+"!submid";
			}, 250);//延迟一段时间开始加载可视区图片
		}
	});
	//5.0添加的新功能============end========================

	function wrapWithA(img,attrsOfA){
		var wrapper = document.createElement("a");
		for(var key in attrsOfA){
			wrapper.setAttribute(key,attrsOfA[key])
		}
		img.parentNode.insertBefore(wrapper, img);
		img.parentNode.removeChild(img);
		wrapper.appendChild(img);
		return wrapper
	}
	window.images=[];
	document.addEventListener('DOMContentLoaded', function(){
		var isNewData =${isNewData};
		var imgs = window.document.querySelectorAll('#ugc-content img,#souyue-content img');
		for(var i =0 ; i<imgs.length;i++){
			var img = imgs[i]
			var clazz="";
			images.push(img.getAttribute("source"))
			if(!isNewData){
				clazz = "souyue-image souyue-image-default"
			}
			wrapWithA(img,{
				"href":"showimage://"+i,
				"class":clazz
			})
		}
		images=images.join(" ")
		if(window.JavascriptInterface && JavascriptInterface.setImages){
			JavascriptInterface.setImages(images);
		}
	}, false);

})();


